SDL_gamepad.h File Reference
`#include <SDL3/SDL_stdinc.h>`
`#include <SDL3/SDL_error.h>`
`#include <SDL3/SDL_guid.h>`
`#include <SDL3/SDL_iostream.h>`
`#include <SDL3/SDL_joystick.h>`
`#include <SDL3/SDL_power.h>`
`#include <SDL3/SDL_properties.h>`
`#include <SDL3/SDL_sensor.h>`
`#include <SDL3/SDL_begin_code.h>`
`#include <SDL3/SDL_close_code.h>`
Include dependency graph for SDL_gamepad.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | SDL_GamepadBinding

## Macros

#define | SDL_PROP_GAMEPAD_CAP_MONO_LED_BOOLEAN SDL_PROP_JOYSTICK_CAP_MONO_LED_BOOLEAN
#define | SDL_PROP_GAMEPAD_CAP_RGB_LED_BOOLEAN SDL_PROP_JOYSTICK_CAP_RGB_LED_BOOLEAN
#define | SDL_PROP_GAMEPAD_CAP_PLAYER_LED_BOOLEAN SDL_PROP_JOYSTICK_CAP_PLAYER_LED_BOOLEAN
#define | SDL_PROP_GAMEPAD_CAP_RUMBLE_BOOLEAN SDL_PROP_JOYSTICK_CAP_RUMBLE_BOOLEAN
#define | SDL_PROP_GAMEPAD_CAP_TRIGGER_RUMBLE_BOOLEAN SDL_PROP_JOYSTICK_CAP_TRIGGER_RUMBLE_BOOLEAN

## Typedefs

typedef struct SDL_Gamepad | SDL_Gamepad

## Enumerations

enum

SDL_GamepadType {
SDL_GAMEPAD_TYPE_UNKNOWN = 0 ,
SDL_GAMEPAD_TYPE_STANDARD ,
SDL_GAMEPAD_TYPE_XBOX360 ,
SDL_GAMEPAD_TYPE_XBOXONE ,
SDL_GAMEPAD_TYPE_PS3 ,
SDL_GAMEPAD_TYPE_PS4 ,
SDL_GAMEPAD_TYPE_PS5 ,
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_PRO ,
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_LEFT ,
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_RIGHT ,
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_PAIR ,
SDL_GAMEPAD_TYPE_GAMECUBE ,
SDL_GAMEPAD_TYPE_COUNT
}

enum

SDL_GamepadButton {
SDL_GAMEPAD_BUTTON_INVALID = -1 ,
SDL_GAMEPAD_BUTTON_SOUTH ,
SDL_GAMEPAD_BUTTON_EAST ,
SDL_GAMEPAD_BUTTON_WEST ,
SDL_GAMEPAD_BUTTON_NORTH ,
SDL_GAMEPAD_BUTTON_BACK ,
SDL_GAMEPAD_BUTTON_GUIDE ,
SDL_GAMEPAD_BUTTON_START ,
SDL_GAMEPAD_BUTTON_LEFT_STICK ,
SDL_GAMEPAD_BUTTON_RIGHT_STICK ,
SDL_GAMEPAD_BUTTON_LEFT_SHOULDER ,
SDL_GAMEPAD_BUTTON_RIGHT_SHOULDER ,
SDL_GAMEPAD_BUTTON_DPAD_UP ,
SDL_GAMEPAD_BUTTON_DPAD_DOWN ,
SDL_GAMEPAD_BUTTON_DPAD_LEFT ,
SDL_GAMEPAD_BUTTON_DPAD_RIGHT ,
SDL_GAMEPAD_BUTTON_MISC1 ,
SDL_GAMEPAD_BUTTON_RIGHT_PADDLE1 ,
SDL_GAMEPAD_BUTTON_LEFT_PADDLE1 ,
SDL_GAMEPAD_BUTTON_RIGHT_PADDLE2 ,
SDL_GAMEPAD_BUTTON_LEFT_PADDLE2 ,
SDL_GAMEPAD_BUTTON_TOUCHPAD ,
SDL_GAMEPAD_BUTTON_MISC2 ,
SDL_GAMEPAD_BUTTON_MISC3 ,
SDL_GAMEPAD_BUTTON_MISC4 ,
SDL_GAMEPAD_BUTTON_MISC5 ,
SDL_GAMEPAD_BUTTON_MISC6 ,
SDL_GAMEPAD_BUTTON_COUNT
}

enum | SDL_GamepadButtonLabel { SDL_GAMEPAD_BUTTON_LABEL_UNKNOWN , SDL_GAMEPAD_BUTTON_LABEL_A , SDL_GAMEPAD_BUTTON_LABEL_B , SDL_GAMEPAD_BUTTON_LABEL_X , SDL_GAMEPAD_BUTTON_LABEL_Y , SDL_GAMEPAD_BUTTON_LABEL_CROSS , SDL_GAMEPAD_BUTTON_LABEL_CIRCLE , SDL_GAMEPAD_BUTTON_LABEL_SQUARE , SDL_GAMEPAD_BUTTON_LABEL_TRIANGLE }
enum | SDL_GamepadAxis { SDL_GAMEPAD_AXIS_INVALID = -1 , SDL_GAMEPAD_AXIS_LEFTX , SDL_GAMEPAD_AXIS_LEFTY , SDL_GAMEPAD_AXIS_RIGHTX , SDL_GAMEPAD_AXIS_RIGHTY , SDL_GAMEPAD_AXIS_LEFT_TRIGGER , SDL_GAMEPAD_AXIS_RIGHT_TRIGGER , SDL_GAMEPAD_AXIS_COUNT }
enum | SDL_GamepadBindingType { SDL_GAMEPAD_BINDTYPE_NONE = 0 , SDL_GAMEPAD_BINDTYPE_BUTTON , SDL_GAMEPAD_BINDTYPE_AXIS , SDL_GAMEPAD_BINDTYPE_HAT }

## Functions

int | SDL_AddGamepadMapping (const char *mapping)
int | SDL_AddGamepadMappingsFromIO (SDL_IOStream *src, bool closeio)
int | SDL_AddGamepadMappingsFromFile (const char *file)
bool | SDL_ReloadGamepadMappings (void)
char ** | SDL_GetGamepadMappings (int *count)
char * | SDL_GetGamepadMappingForGUID (SDL_GUID guid)
char * | SDL_GetGamepadMapping (SDL_Gamepad *gamepad)
bool | SDL_SetGamepadMapping (SDL_JoystickID instance_id, const char *mapping)
bool | SDL_HasGamepad (void)
SDL_JoystickID * | SDL_GetGamepads (int *count)
bool | SDL_IsGamepad (SDL_JoystickID instance_id)
const char * | SDL_GetGamepadNameForID (SDL_JoystickID instance_id)
const char * | SDL_GetGamepadPathForID (SDL_JoystickID instance_id)
int | SDL_GetGamepadPlayerIndexForID (SDL_JoystickID instance_id)
SDL_GUID | SDL_GetGamepadGUIDForID (SDL_JoystickID instance_id)
Uint16 | SDL_GetGamepadVendorForID (SDL_JoystickID instance_id)
Uint16 | SDL_GetGamepadProductForID (SDL_JoystickID instance_id)
Uint16 | SDL_GetGamepadProductVersionForID (SDL_JoystickID instance_id)
SDL_GamepadType | SDL_GetGamepadTypeForID (SDL_JoystickID instance_id)
SDL_GamepadType | SDL_GetRealGamepadTypeForID (SDL_JoystickID instance_id)
char * | SDL_GetGamepadMappingForID (SDL_JoystickID instance_id)
SDL_Gamepad * | SDL_OpenGamepad (SDL_JoystickID instance_id)
SDL_Gamepad * | SDL_GetGamepadFromID (SDL_JoystickID instance_id)
SDL_Gamepad * | SDL_GetGamepadFromPlayerIndex (int player_index)
SDL_PropertiesID | SDL_GetGamepadProperties (SDL_Gamepad *gamepad)
SDL_JoystickID | SDL_GetGamepadID (SDL_Gamepad *gamepad)
const char * | SDL_GetGamepadName (SDL_Gamepad *gamepad)
const char * | SDL_GetGamepadPath (SDL_Gamepad *gamepad)
SDL_GamepadType | SDL_GetGamepadType (SDL_Gamepad *gamepad)
SDL_GamepadType | SDL_GetRealGamepadType (SDL_Gamepad *gamepad)
int | SDL_GetGamepadPlayerIndex (SDL_Gamepad *gamepad)
bool | SDL_SetGamepadPlayerIndex (SDL_Gamepad *gamepad, int player_index)
Uint16 | SDL_GetGamepadVendor (SDL_Gamepad *gamepad)
Uint16 | SDL_GetGamepadProduct (SDL_Gamepad *gamepad)
Uint16 | SDL_GetGamepadProductVersion (SDL_Gamepad *gamepad)
Uint16 | SDL_GetGamepadFirmwareVersion (SDL_Gamepad *gamepad)
const char * | SDL_GetGamepadSerial (SDL_Gamepad *gamepad)
Uint64 | SDL_GetGamepadSteamHandle (SDL_Gamepad *gamepad)
SDL_JoystickConnectionState | SDL_GetGamepadConnectionState (SDL_Gamepad *gamepad)
SDL_PowerState | SDL_GetGamepadPowerInfo (SDL_Gamepad *gamepad, int *percent)
bool | SDL_GamepadConnected (SDL_Gamepad *gamepad)
SDL_Joystick * | SDL_GetGamepadJoystick (SDL_Gamepad *gamepad)
void | SDL_SetGamepadEventsEnabled (bool enabled)
bool | SDL_GamepadEventsEnabled (void)
SDL_GamepadBinding ** | SDL_GetGamepadBindings (SDL_Gamepad *gamepad, int *count)
void | SDL_UpdateGamepads (void)
SDL_GamepadType | SDL_GetGamepadTypeFromString (const char *str)
const char * | SDL_GetGamepadStringForType (SDL_GamepadType type)
SDL_GamepadAxis | SDL_GetGamepadAxisFromString (const char *str)
const char * | SDL_GetGamepadStringForAxis (SDL_GamepadAxis axis)
bool | SDL_GamepadHasAxis (SDL_Gamepad *gamepad, SDL_GamepadAxis axis)
Sint16 | SDL_GetGamepadAxis (SDL_Gamepad *gamepad, SDL_GamepadAxis axis)
SDL_GamepadButton | SDL_GetGamepadButtonFromString (const char *str)
const char * | SDL_GetGamepadStringForButton (SDL_GamepadButton button)
bool | SDL_GamepadHasButton (SDL_Gamepad *gamepad, SDL_GamepadButton button)
bool | SDL_GetGamepadButton (SDL_Gamepad *gamepad, SDL_GamepadButton button)
SDL_GamepadButtonLabel | SDL_GetGamepadButtonLabelForType (SDL_GamepadType type, SDL_GamepadButton button)
SDL_GamepadButtonLabel | SDL_GetGamepadButtonLabel (SDL_Gamepad *gamepad, SDL_GamepadButton button)
int | SDL_GetNumGamepadTouchpads (SDL_Gamepad *gamepad)
int | SDL_GetNumGamepadTouchpadFingers (SDL_Gamepad *gamepad, int touchpad)
bool | SDL_GetGamepadTouchpadFinger (SDL_Gamepad *gamepad, int touchpad, int finger, bool *down, float *x, float *y, float *pressure)
bool | SDL_GamepadHasSensor (SDL_Gamepad *gamepad, SDL_SensorType type)
bool | SDL_SetGamepadSensorEnabled (SDL_Gamepad *gamepad, SDL_SensorType type, bool enabled)
bool | SDL_GamepadSensorEnabled (SDL_Gamepad *gamepad, SDL_SensorType type)
float | SDL_GetGamepadSensorDataRate (SDL_Gamepad *gamepad, SDL_SensorType type)
bool | SDL_GetGamepadSensorData (SDL_Gamepad *gamepad, SDL_SensorType type, float *data, int num_values)
bool | SDL_RumbleGamepad (SDL_Gamepad *gamepad, Uint16 low_frequency_rumble, Uint16 high_frequency_rumble, Uint32 duration_ms)
bool | SDL_RumbleGamepadTriggers (SDL_Gamepad *gamepad, Uint16 left_rumble, Uint16 right_rumble, Uint32 duration_ms)
bool | SDL_SetGamepadLED (SDL_Gamepad *gamepad, Uint8 red, Uint8 green, Uint8 blue)
bool | SDL_SendGamepadEffect (SDL_Gamepad *gamepad, const void *data, int size)
void | SDL_CloseGamepad (SDL_Gamepad *gamepad)
const char * | SDL_GetGamepadAppleSFSymbolsNameForButton (SDL_Gamepad *gamepad, SDL_GamepadButton button)
const char * | SDL_GetGamepadAppleSFSymbolsNameForAxis (SDL_Gamepad *gamepad, SDL_GamepadAxis axis)

## Macro Definition Documentation

## SDL_PROP_GAMEPAD_CAP_MONO_LED_BOOLEAN

#define SDL_PROP_GAMEPAD_CAP_MONO_LED_BOOLEAN SDL_PROP_JOYSTICK_CAP_MONO_LED_BOOLEAN

Definition at line 813 of file SDL_gamepad.h.

## SDL_PROP_GAMEPAD_CAP_PLAYER_LED_BOOLEAN

#define SDL_PROP_GAMEPAD_CAP_PLAYER_LED_BOOLEAN SDL_PROP_JOYSTICK_CAP_PLAYER_LED_BOOLEAN

Definition at line 815 of file SDL_gamepad.h.

## SDL_PROP_GAMEPAD_CAP_RGB_LED_BOOLEAN

#define SDL_PROP_GAMEPAD_CAP_RGB_LED_BOOLEAN SDL_PROP_JOYSTICK_CAP_RGB_LED_BOOLEAN

Definition at line 814 of file SDL_gamepad.h.

## SDL_PROP_GAMEPAD_CAP_RUMBLE_BOOLEAN

#define SDL_PROP_GAMEPAD_CAP_RUMBLE_BOOLEAN SDL_PROP_JOYSTICK_CAP_RUMBLE_BOOLEAN

Definition at line 816 of file SDL_gamepad.h.

## SDL_PROP_GAMEPAD_CAP_TRIGGER_RUMBLE_BOOLEAN

#define SDL_PROP_GAMEPAD_CAP_TRIGGER_RUMBLE_BOOLEAN SDL_PROP_JOYSTICK_CAP_TRIGGER_RUMBLE_BOOLEAN

Definition at line 817 of file SDL_gamepad.h.

## Typedef Documentation

## SDL_Gamepad

typedef struct SDL_Gamepad SDL_Gamepad

# CategoryGamepad

SDL provides a low-level joystick API, which just treats joysticks as an arbitrary pile of buttons, axes, and hat switches. If you're planning to write your own control configuration screen, this can give you a lot of flexibility, but that's a lot of work, and most things that we consider "joysticks" now are actually console-style gamepads. So SDL provides the gamepad API on top of the lower-level joystick functionality.

The difference between a joystick and a gamepad is that a gamepad tells you where a button or axis is on the device. You don't speak to gamepads in terms of arbitrary numbers like "button 3" or "axis 2" but in standard locations: the d-pad, the shoulder buttons, triggers, A/B/X/Y (or X/O/Square/Triangle, if you will).

One turns a joystick into a gamepad by providing a magic configuration string, which tells SDL the details of a specific device: when you see this specific hardware, if button 2 gets pressed, this is actually D-Pad Up, etc.

SDL has many popular controllers configured out of the box, and users can add their own controller details through an environment variable if it's otherwise unknown to SDL.

In order to use these functions, SDL_Init() must have been called with the SDL_INIT_GAMEPAD flag. This causes SDL to scan the system for gamepads, and load appropriate drivers.

If you're using SDL gamepad support in a Steam game, you must call SteamAPI_InitEx() before calling SDL_Init().

If you would like to receive gamepad updates while the application is in the background, you should set the following hint before calling SDL_Init(): SDL_HINT_JOYSTICK_ALLOW_BACKGROUND_EVENTS

Gamepads support various optional features such as rumble, color LEDs, touchpad, gyro, etc. The support for these features varies depending on the controller and OS support available. You can check for LED and rumble capabilities at runtime by calling SDL_GetGamepadProperties() and checking the various capability properties. You can check for touchpad by calling SDL_GetNumGamepadTouchpads() and check for gyro and accelerometer by calling SDL_GamepadHasSensor().

By default SDL will try to use the most capable driver available, but you can tune which OS drivers to use with the various joystick hints in SDL_hints.h.

Your application should always support gamepad hotplugging. On some platforms like Xbox, Steam Deck, etc., this is a requirement for certification. On other platforms, like macOS and Windows when using Windows.Gaming.Input, controllers may not be available at startup and will come in at some point after you've started processing events. The structure used to identify an SDL gamepad

Since
  This struct is available since SDL 3.2.0.

Definition at line 100 of file SDL_gamepad.h.

## Enumeration Type Documentation

## SDL_GamepadAxis

enum SDL_GamepadAxis

The list of axes available on a gamepad

Thumbstick axis values range from SDL_JOYSTICK_AXIS_MIN to SDL_JOYSTICK_AXIS_MAX, and are centered within ~8000 of zero, though advanced UI will allow users to set or autodetect the dead zone, which varies between gamepads.

Trigger axis values range from 0 (released) to SDL_JOYSTICK_AXIS_MAX (fully pressed) when reported by SDL_GetGamepadAxis(). Note that this is not the same range that will be reported by the lower-level SDL_GetJoystickAxis().

Since
  This enum is available since SDL 3.2.0.

Enumerator
SDL_GAMEPAD_AXIS_INVALID |
SDL_GAMEPAD_AXIS_LEFTX |
SDL_GAMEPAD_AXIS_LEFTY |
SDL_GAMEPAD_AXIS_RIGHTX |
SDL_GAMEPAD_AXIS_RIGHTY |
SDL_GAMEPAD_AXIS_LEFT_TRIGGER |
SDL_GAMEPAD_AXIS_RIGHT_TRIGGER |
SDL_GAMEPAD_AXIS_COUNT |

Definition at line 222 of file SDL_gamepad.h.

{
SDL_GAMEPAD_AXIS_INVALID = -1,
SDL_GAMEPAD_AXIS_LEFTX,
SDL_GAMEPAD_AXIS_LEFTY,
SDL_GAMEPAD_AXIS_RIGHTX,
SDL_GAMEPAD_AXIS_RIGHTY,
SDL_GAMEPAD_AXIS_LEFT_TRIGGER,
SDL_GAMEPAD_AXIS_RIGHT_TRIGGER,
SDL_GAMEPAD_AXIS_COUNT
} SDL_GamepadAxis;
SDL_GamepadAxis
SDL_GamepadAxis
Definition SDL_gamepad.h:223
SDL_GAMEPAD_AXIS_COUNT
@ SDL_GAMEPAD_AXIS_COUNT
Definition SDL_gamepad.h:231
SDL_GAMEPAD_AXIS_RIGHTX
@ SDL_GAMEPAD_AXIS_RIGHTX
Definition SDL_gamepad.h:227
SDL_GAMEPAD_AXIS_RIGHT_TRIGGER
@ SDL_GAMEPAD_AXIS_RIGHT_TRIGGER
Definition SDL_gamepad.h:230
SDL_GAMEPAD_AXIS_LEFTX
@ SDL_GAMEPAD_AXIS_LEFTX
Definition SDL_gamepad.h:225
SDL_GAMEPAD_AXIS_INVALID
@ SDL_GAMEPAD_AXIS_INVALID
Definition SDL_gamepad.h:224
SDL_GAMEPAD_AXIS_LEFTY
@ SDL_GAMEPAD_AXIS_LEFTY
Definition SDL_gamepad.h:226
SDL_GAMEPAD_AXIS_LEFT_TRIGGER
@ SDL_GAMEPAD_AXIS_LEFT_TRIGGER
Definition SDL_gamepad.h:229
SDL_GAMEPAD_AXIS_RIGHTY
@ SDL_GAMEPAD_AXIS_RIGHTY
Definition SDL_gamepad.h:228

## SDL_GamepadBindingType

enum SDL_GamepadBindingType

Types of gamepad control bindings.

A gamepad is a collection of bindings that map arbitrary joystick buttons, axes and hat switches to specific positions on a generic console-style gamepad. This enum is used as part of SDL_GamepadBinding to specify those mappings.

Since
  This enum is available since SDL 3.2.0.

Enumerator
SDL_GAMEPAD_BINDTYPE_NONE |
SDL_GAMEPAD_BINDTYPE_BUTTON |
SDL_GAMEPAD_BINDTYPE_AXIS |
SDL_GAMEPAD_BINDTYPE_HAT |

Definition at line 244 of file SDL_gamepad.h.

{
SDL_GAMEPAD_BINDTYPE_NONE = 0,
SDL_GAMEPAD_BINDTYPE_BUTTON,
SDL_GAMEPAD_BINDTYPE_AXIS,
SDL_GAMEPAD_BINDTYPE_HAT
} SDL_GamepadBindingType;
SDL_GamepadBindingType
SDL_GamepadBindingType
Definition SDL_gamepad.h:245
SDL_GAMEPAD_BINDTYPE_HAT
@ SDL_GAMEPAD_BINDTYPE_HAT
Definition SDL_gamepad.h:249
SDL_GAMEPAD_BINDTYPE_BUTTON
@ SDL_GAMEPAD_BINDTYPE_BUTTON
Definition SDL_gamepad.h:247
SDL_GAMEPAD_BINDTYPE_NONE
@ SDL_GAMEPAD_BINDTYPE_NONE
Definition SDL_gamepad.h:246
SDL_GAMEPAD_BINDTYPE_AXIS
@ SDL_GAMEPAD_BINDTYPE_AXIS
Definition SDL_gamepad.h:248

## SDL_GamepadButton

enum SDL_GamepadButton

The list of buttons available on a gamepad

For controllers that use a diamond pattern for the face buttons, the south/east/west/north buttons below correspond to the locations in the diamond pattern. For Xbox controllers, this would be A/B/X/Y, for Nintendo Switch controllers, this would be B/A/Y/X, for GameCube controllers this would be A/X/B/Y, for PlayStation controllers this would be Cross/Circle/Square/Triangle.

For controllers that don't use a diamond pattern for the face buttons, the south/east/west/north buttons indicate the buttons labeled A, B, C, D, or 1, 2, 3, 4, or for controllers that aren't labeled, they are the primary, secondary, etc. buttons.

The activate action is often the south button and the cancel action is often the east button, but in some regions this is reversed, so your game should allow remapping actions based on user preferences.

You can query the labels for the face buttons using SDL_GetGamepadButtonLabel()

Since
  This enum is available since SDL 3.2.0.

Enumerator
SDL_GAMEPAD_BUTTON_INVALID |
SDL_GAMEPAD_BUTTON_SOUTH | Bottom face button (e.g. Xbox A button)
SDL_GAMEPAD_BUTTON_EAST | Right face button (e.g. Xbox B button)
SDL_GAMEPAD_BUTTON_WEST | Left face button (e.g. Xbox X button)
SDL_GAMEPAD_BUTTON_NORTH | Top face button (e.g. Xbox Y button)
SDL_GAMEPAD_BUTTON_BACK |
SDL_GAMEPAD_BUTTON_GUIDE |
SDL_GAMEPAD_BUTTON_START |
SDL_GAMEPAD_BUTTON_LEFT_STICK |
SDL_GAMEPAD_BUTTON_RIGHT_STICK |
SDL_GAMEPAD_BUTTON_LEFT_SHOULDER |
SDL_GAMEPAD_BUTTON_RIGHT_SHOULDER |
SDL_GAMEPAD_BUTTON_DPAD_UP |
SDL_GAMEPAD_BUTTON_DPAD_DOWN |
SDL_GAMEPAD_BUTTON_DPAD_LEFT |
SDL_GAMEPAD_BUTTON_DPAD_RIGHT |
SDL_GAMEPAD_BUTTON_MISC1 | Additional button (e.g. Xbox Series X share button, PS5 microphone button, Nintendo Switch Pro capture button, Steam Controller QAM button, Amazon Luna microphone button, Google Stadia capture button)
SDL_GAMEPAD_BUTTON_RIGHT_PADDLE1 | Upper or primary paddle, under your right hand (e.g. Xbox Elite paddle P1, DualSense Edge RB button, Right Joy-Con SR button, Steam Controller R4 button)
SDL_GAMEPAD_BUTTON_LEFT_PADDLE1 | Upper or primary paddle, under your left hand (e.g. Xbox Elite paddle P3, DualSense Edge LB button, Left Joy-Con SL button, Steam Controller L4 button)
SDL_GAMEPAD_BUTTON_RIGHT_PADDLE2 | Lower or secondary paddle, under your right hand (e.g. Xbox Elite paddle P2, DualSense Edge right Fn button, Right Joy-Con SL button, Steam Controller R5 button)
SDL_GAMEPAD_BUTTON_LEFT_PADDLE2 | Lower or secondary paddle, under your left hand (e.g. Xbox Elite paddle P4, DualSense Edge left Fn button, Left Joy-Con SR button, Steam Controller L5 button)
SDL_GAMEPAD_BUTTON_TOUCHPAD | PS4/PS5 touchpad button
SDL_GAMEPAD_BUTTON_MISC2 | Additional button
SDL_GAMEPAD_BUTTON_MISC3 | Additional button (e.g. Nintendo GameCube left trigger click)
SDL_GAMEPAD_BUTTON_MISC4 | Additional button (e.g. Nintendo GameCube right trigger click)
SDL_GAMEPAD_BUTTON_MISC5 | Additional button
SDL_GAMEPAD_BUTTON_MISC6 | Additional button
SDL_GAMEPAD_BUTTON_COUNT |

Definition at line 152 of file SDL_gamepad.h.

{
SDL_GAMEPAD_BUTTON_INVALID = -1,
SDL_GAMEPAD_BUTTON_SOUTH, /**< Bottom face button (e.g. Xbox A button) */
SDL_GAMEPAD_BUTTON_EAST, /**< Right face button (e.g. Xbox B button) */
SDL_GAMEPAD_BUTTON_WEST, /**< Left face button (e.g. Xbox X button) */
SDL_GAMEPAD_BUTTON_NORTH, /**< Top face button (e.g. Xbox Y button) */
SDL_GAMEPAD_BUTTON_BACK,
SDL_GAMEPAD_BUTTON_GUIDE,
SDL_GAMEPAD_BUTTON_START,
SDL_GAMEPAD_BUTTON_LEFT_STICK,
SDL_GAMEPAD_BUTTON_RIGHT_STICK,
SDL_GAMEPAD_BUTTON_LEFT_SHOULDER,
SDL_GAMEPAD_BUTTON_RIGHT_SHOULDER,
SDL_GAMEPAD_BUTTON_DPAD_UP,
SDL_GAMEPAD_BUTTON_DPAD_DOWN,
SDL_GAMEPAD_BUTTON_DPAD_LEFT,
SDL_GAMEPAD_BUTTON_DPAD_RIGHT,
SDL_GAMEPAD_BUTTON_MISC1, /**< Additional button (e.g. Xbox Series X share button, PS5 microphone button, Nintendo Switch Pro capture button, Steam Controller QAM button, Amazon Luna microphone button, Google Stadia capture button) */
SDL_GAMEPAD_BUTTON_RIGHT_PADDLE1, /**< Upper or primary paddle, under your right hand (e.g. Xbox Elite paddle P1, DualSense Edge RB button, Right Joy-Con SR button, Steam Controller R4 button) */
SDL_GAMEPAD_BUTTON_LEFT_PADDLE1, /**< Upper or primary paddle, under your left hand (e.g. Xbox Elite paddle P3, DualSense Edge LB button, Left Joy-Con SL button, Steam Controller L4 button) */
SDL_GAMEPAD_BUTTON_RIGHT_PADDLE2, /**< Lower or secondary paddle, under your right hand (e.g. Xbox Elite paddle P2, DualSense Edge right Fn button, Right Joy-Con SL button, Steam Controller R5 button) */
SDL_GAMEPAD_BUTTON_LEFT_PADDLE2, /**< Lower or secondary paddle, under your left hand (e.g. Xbox Elite paddle P4, DualSense Edge left Fn button, Left Joy-Con SR button, Steam Controller L5 button) */
SDL_GAMEPAD_BUTTON_TOUCHPAD, /**< PS4/PS5 touchpad button */
SDL_GAMEPAD_BUTTON_MISC2, /**< Additional button */
SDL_GAMEPAD_BUTTON_MISC3, /**< Additional button (e.g. Nintendo GameCube left trigger click) */
SDL_GAMEPAD_BUTTON_MISC4, /**< Additional button (e.g. Nintendo GameCube right trigger click) */
SDL_GAMEPAD_BUTTON_MISC5, /**< Additional button */
SDL_GAMEPAD_BUTTON_MISC6, /**< Additional button */
SDL_GAMEPAD_BUTTON_COUNT
} SDL_GamepadButton;
SDL_GamepadButton
SDL_GamepadButton
Definition SDL_gamepad.h:153
SDL_GAMEPAD_BUTTON_LEFT_PADDLE2
@ SDL_GAMEPAD_BUTTON_LEFT_PADDLE2
Definition SDL_gamepad.h:174
SDL_GAMEPAD_BUTTON_WEST
@ SDL_GAMEPAD_BUTTON_WEST
Definition SDL_gamepad.h:157
SDL_GAMEPAD_BUTTON_EAST
@ SDL_GAMEPAD_BUTTON_EAST
Definition SDL_gamepad.h:156
SDL_GAMEPAD_BUTTON_MISC2
@ SDL_GAMEPAD_BUTTON_MISC2
Definition SDL_gamepad.h:176
SDL_GAMEPAD_BUTTON_GUIDE
@ SDL_GAMEPAD_BUTTON_GUIDE
Definition SDL_gamepad.h:160
SDL_GAMEPAD_BUTTON_LEFT_STICK
@ SDL_GAMEPAD_BUTTON_LEFT_STICK
Definition SDL_gamepad.h:162
SDL_GAMEPAD_BUTTON_TOUCHPAD
@ SDL_GAMEPAD_BUTTON_TOUCHPAD
Definition SDL_gamepad.h:175
SDL_GAMEPAD_BUTTON_MISC4
@ SDL_GAMEPAD_BUTTON_MISC4
Definition SDL_gamepad.h:178
SDL_GAMEPAD_BUTTON_MISC5
@ SDL_GAMEPAD_BUTTON_MISC5
Definition SDL_gamepad.h:179
SDL_GAMEPAD_BUTTON_LEFT_SHOULDER
@ SDL_GAMEPAD_BUTTON_LEFT_SHOULDER
Definition SDL_gamepad.h:164
SDL_GAMEPAD_BUTTON_DPAD_DOWN
@ SDL_GAMEPAD_BUTTON_DPAD_DOWN
Definition SDL_gamepad.h:167
SDL_GAMEPAD_BUTTON_RIGHT_PADDLE1
@ SDL_GAMEPAD_BUTTON_RIGHT_PADDLE1
Definition SDL_gamepad.h:171
SDL_GAMEPAD_BUTTON_INVALID
@ SDL_GAMEPAD_BUTTON_INVALID
Definition SDL_gamepad.h:154
SDL_GAMEPAD_BUTTON_MISC6
@ SDL_GAMEPAD_BUTTON_MISC6
Definition SDL_gamepad.h:180
SDL_GAMEPAD_BUTTON_MISC1
@ SDL_GAMEPAD_BUTTON_MISC1
Definition SDL_gamepad.h:170
SDL_GAMEPAD_BUTTON_BACK
@ SDL_GAMEPAD_BUTTON_BACK
Definition SDL_gamepad.h:159
SDL_GAMEPAD_BUTTON_DPAD_UP
@ SDL_GAMEPAD_BUTTON_DPAD_UP
Definition SDL_gamepad.h:166
SDL_GAMEPAD_BUTTON_LEFT_PADDLE1
@ SDL_GAMEPAD_BUTTON_LEFT_PADDLE1
Definition SDL_gamepad.h:172
SDL_GAMEPAD_BUTTON_RIGHT_STICK
@ SDL_GAMEPAD_BUTTON_RIGHT_STICK
Definition SDL_gamepad.h:163
SDL_GAMEPAD_BUTTON_START
@ SDL_GAMEPAD_BUTTON_START
Definition SDL_gamepad.h:161
SDL_GAMEPAD_BUTTON_COUNT
@ SDL_GAMEPAD_BUTTON_COUNT
Definition SDL_gamepad.h:181
SDL_GAMEPAD_BUTTON_DPAD_RIGHT
@ SDL_GAMEPAD_BUTTON_DPAD_RIGHT
Definition SDL_gamepad.h:169
SDL_GAMEPAD_BUTTON_RIGHT_SHOULDER
@ SDL_GAMEPAD_BUTTON_RIGHT_SHOULDER
Definition SDL_gamepad.h:165
SDL_GAMEPAD_BUTTON_MISC3
@ SDL_GAMEPAD_BUTTON_MISC3
Definition SDL_gamepad.h:177
SDL_GAMEPAD_BUTTON_RIGHT_PADDLE2
@ SDL_GAMEPAD_BUTTON_RIGHT_PADDLE2
Definition SDL_gamepad.h:173
SDL_GAMEPAD_BUTTON_SOUTH
@ SDL_GAMEPAD_BUTTON_SOUTH
Definition SDL_gamepad.h:155
SDL_GAMEPAD_BUTTON_DPAD_LEFT
@ SDL_GAMEPAD_BUTTON_DPAD_LEFT
Definition SDL_gamepad.h:168
SDL_GAMEPAD_BUTTON_NORTH
@ SDL_GAMEPAD_BUTTON_NORTH
Definition SDL_gamepad.h:158

## SDL_GamepadButtonLabel

enum SDL_GamepadButtonLabel

The set of gamepad button labels

This isn't a complete set, just the face buttons to make it easy to show button prompts.

For a complete set, you should look at the button and gamepad type and have a set of symbols that work well with your art style.

Since
  This enum is available since SDL 3.2.0.

Enumerator
SDL_GAMEPAD_BUTTON_LABEL_UNKNOWN |
SDL_GAMEPAD_BUTTON_LABEL_A |
SDL_GAMEPAD_BUTTON_LABEL_B |
SDL_GAMEPAD_BUTTON_LABEL_X |
SDL_GAMEPAD_BUTTON_LABEL_Y |
SDL_GAMEPAD_BUTTON_LABEL_CROSS |
SDL_GAMEPAD_BUTTON_LABEL_CIRCLE |
SDL_GAMEPAD_BUTTON_LABEL_SQUARE |
SDL_GAMEPAD_BUTTON_LABEL_TRIANGLE |

Definition at line 195 of file SDL_gamepad.h.

{
SDL_GAMEPAD_BUTTON_LABEL_UNKNOWN,
SDL_GAMEPAD_BUTTON_LABEL_A,
SDL_GAMEPAD_BUTTON_LABEL_B,
SDL_GAMEPAD_BUTTON_LABEL_X,
SDL_GAMEPAD_BUTTON_LABEL_Y,
SDL_GAMEPAD_BUTTON_LABEL_CROSS,
SDL_GAMEPAD_BUTTON_LABEL_CIRCLE,
SDL_GAMEPAD_BUTTON_LABEL_SQUARE,
SDL_GAMEPAD_BUTTON_LABEL_TRIANGLE
} SDL_GamepadButtonLabel;
SDL_GamepadButtonLabel
SDL_GamepadButtonLabel
Definition SDL_gamepad.h:196
SDL_GAMEPAD_BUTTON_LABEL_CIRCLE
@ SDL_GAMEPAD_BUTTON_LABEL_CIRCLE
Definition SDL_gamepad.h:203
SDL_GAMEPAD_BUTTON_LABEL_X
@ SDL_GAMEPAD_BUTTON_LABEL_X
Definition SDL_gamepad.h:200
SDL_GAMEPAD_BUTTON_LABEL_TRIANGLE
@ SDL_GAMEPAD_BUTTON_LABEL_TRIANGLE
Definition SDL_gamepad.h:205
SDL_GAMEPAD_BUTTON_LABEL_B
@ SDL_GAMEPAD_BUTTON_LABEL_B
Definition SDL_gamepad.h:199
SDL_GAMEPAD_BUTTON_LABEL_SQUARE
@ SDL_GAMEPAD_BUTTON_LABEL_SQUARE
Definition SDL_gamepad.h:204
SDL_GAMEPAD_BUTTON_LABEL_CROSS
@ SDL_GAMEPAD_BUTTON_LABEL_CROSS
Definition SDL_gamepad.h:202
SDL_GAMEPAD_BUTTON_LABEL_UNKNOWN
@ SDL_GAMEPAD_BUTTON_LABEL_UNKNOWN
Definition SDL_gamepad.h:197
SDL_GAMEPAD_BUTTON_LABEL_Y
@ SDL_GAMEPAD_BUTTON_LABEL_Y
Definition SDL_gamepad.h:201
SDL_GAMEPAD_BUTTON_LABEL_A
@ SDL_GAMEPAD_BUTTON_LABEL_A
Definition SDL_gamepad.h:198

## SDL_GamepadType

enum SDL_GamepadType

Standard gamepad types.

This type does not necessarily map to first-party controllers from Microsoft/Sony/Nintendo; in many cases, third-party controllers can report as these, either because they were designed for a specific console, or they simply most closely match that console's controllers (does it have A/B/X/Y buttons or X/O/Square/Triangle? Does it have a touchpad? etc).

Enumerator
SDL_GAMEPAD_TYPE_UNKNOWN |
SDL_GAMEPAD_TYPE_STANDARD |
SDL_GAMEPAD_TYPE_XBOX360 |
SDL_GAMEPAD_TYPE_XBOXONE |
SDL_GAMEPAD_TYPE_PS3 |
SDL_GAMEPAD_TYPE_PS4 |
SDL_GAMEPAD_TYPE_PS5 |
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_PRO |
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_LEFT |
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_RIGHT |
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_PAIR |
SDL_GAMEPAD_TYPE_GAMECUBE |
SDL_GAMEPAD_TYPE_COUNT |

Definition at line 111 of file SDL_gamepad.h.

{
SDL_GAMEPAD_TYPE_UNKNOWN = 0,
SDL_GAMEPAD_TYPE_STANDARD,
SDL_GAMEPAD_TYPE_XBOX360,
SDL_GAMEPAD_TYPE_XBOXONE,
SDL_GAMEPAD_TYPE_PS3,
SDL_GAMEPAD_TYPE_PS4,
SDL_GAMEPAD_TYPE_PS5,
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_PRO,
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_LEFT,
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_RIGHT,
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_PAIR,
SDL_GAMEPAD_TYPE_GAMECUBE,
SDL_GAMEPAD_TYPE_COUNT
} SDL_GamepadType;
SDL_GamepadType
SDL_GamepadType
Definition SDL_gamepad.h:112
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_LEFT
@ SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_LEFT
Definition SDL_gamepad.h:121
SDL_GAMEPAD_TYPE_PS5
@ SDL_GAMEPAD_TYPE_PS5
Definition SDL_gamepad.h:119
SDL_GAMEPAD_TYPE_COUNT
@ SDL_GAMEPAD_TYPE_COUNT
Definition SDL_gamepad.h:125
SDL_GAMEPAD_TYPE_UNKNOWN
@ SDL_GAMEPAD_TYPE_UNKNOWN
Definition SDL_gamepad.h:113
SDL_GAMEPAD_TYPE_XBOX360
@ SDL_GAMEPAD_TYPE_XBOX360
Definition SDL_gamepad.h:115
SDL_GAMEPAD_TYPE_GAMECUBE
@ SDL_GAMEPAD_TYPE_GAMECUBE
Definition SDL_gamepad.h:124
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_RIGHT
@ SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_RIGHT
Definition SDL_gamepad.h:122
SDL_GAMEPAD_TYPE_XBOXONE
@ SDL_GAMEPAD_TYPE_XBOXONE
Definition SDL_gamepad.h:116
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_PRO
@ SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_PRO
Definition SDL_gamepad.h:120
SDL_GAMEPAD_TYPE_PS4
@ SDL_GAMEPAD_TYPE_PS4
Definition SDL_gamepad.h:118
SDL_GAMEPAD_TYPE_PS3
@ SDL_GAMEPAD_TYPE_PS3
Definition SDL_gamepad.h:117
SDL_GAMEPAD_TYPE_STANDARD
@ SDL_GAMEPAD_TYPE_STANDARD
Definition SDL_gamepad.h:114
SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_PAIR
@ SDL_GAMEPAD_TYPE_NINTENDO_SWITCH_JOYCON_PAIR
Definition SDL_gamepad.h:123

## Function Documentation

## SDL_AddGamepadMapping()

int SDL_AddGamepadMapping | ( | const char * | mapping | ) |

extern

Add support for gamepads that SDL is unaware of or change the binding of an existing gamepad.

The mapping string has the format "GUID,name,mapping", where GUID is the string value from SDL_GUIDToString(), name is the human readable string for the device and mappings are gamepad mappings to joystick ones. Under Windows there is a reserved GUID of "xinput" that covers all XInput devices. The mapping format for joystick is:

- bX: a joystick button, index X
- hX.Y: hat X with value Y
- aX: axis X of the joystick

Buttons can be used as a gamepad axes and vice versa.

If a device with this GUID is already plugged in, SDL will generate an SDL_EVENT_GAMEPAD_ADDED event.

This string shows an example of a valid mapping for a gamepad:

"341a3608000000000000504944564944,Afterglow PS3 Controller,a:b1,b:b2,y:b3,x:b0,start:b9,guide:b12,back:b8,dpup:h0.1,dpleft:h0.8,dpdown:h0.4,dpright:h0.2,leftshoulder:b4,rightshoulder:b5,leftstick:b10,rightstick:b11,leftx:a0,lefty:a1,rightx:a2,righty:a3,lefttrigger:b6,righttrigger:b7"

Parameters

  mapping | the mapping string.

Returns
  1 if a new mapping is added, 0 if an existing mapping is updated, -1 on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_AddGamepadMappingsFromFile
  SDL_AddGamepadMappingsFromIO
  SDL_GetGamepadMapping
  SDL_GetGamepadMappingForGUID
  SDL_HINT_GAMECONTROLLERCONFIG
  SDL_HINT_GAMECONTROLLERCONFIG_FILE
  SDL_EVENT_GAMEPAD_ADDED

## SDL_AddGamepadMappingsFromFile()

int SDL_AddGamepadMappingsFromFile | ( | const char * | file | ) |

extern

Load a set of gamepad mappings from a file.

You can call this function several times, if needed, to load different database files.

If a new mapping is loaded for an already known gamepad GUID, the later version will overwrite the one currently loaded.

Any new mappings for already plugged in controllers will generate SDL_EVENT_GAMEPAD_ADDED events.

Mappings not belonging to the current platform or with no platform field specified will be ignored (i.e. mappings for Linux will be ignored in Windows, etc).

Parameters

  file | the mappings file to load.

Returns
  the number of mappings added or -1 on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_AddGamepadMapping
  SDL_AddGamepadMappingsFromIO
  SDL_GetGamepadMapping
  SDL_GetGamepadMappingForGUID
  SDL_HINT_GAMECONTROLLERCONFIG
  SDL_HINT_GAMECONTROLLERCONFIG_FILE
  SDL_EVENT_GAMEPAD_ADDED

## SDL_AddGamepadMappingsFromIO()

int SDL_AddGamepadMappingsFromIO | ( | SDL_IOStream * | src,
|  | bool | closeio )

extern

Load a set of gamepad mappings from an SDL_IOStream.

You can call this function several times, if needed, to load different database files.

If a new mapping is loaded for an already known gamepad GUID, the later version will overwrite the one currently loaded.

Any new mappings for already plugged in controllers will generate SDL_EVENT_GAMEPAD_ADDED events.

Mappings not belonging to the current platform or with no platform field specified will be ignored (i.e. mappings for Linux will be ignored in Windows, etc).

This function will load the text database entirely in memory before processing it, so take this into consideration if you are in a memory constrained environment.

Parameters

  src | the data stream for the mappings to be added.
  closeio | if true, calls SDL_CloseIO() on src before returning, even in the case of an error.

Returns
  the number of mappings added or -1 on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_AddGamepadMapping
  SDL_AddGamepadMappingsFromFile
  SDL_GetGamepadMapping
  SDL_GetGamepadMappingForGUID
  SDL_HINT_GAMECONTROLLERCONFIG
  SDL_HINT_GAMECONTROLLERCONFIG_FILE
  SDL_EVENT_GAMEPAD_ADDED

## SDL_CloseGamepad()

void SDL_CloseGamepad | ( | SDL_Gamepad * | gamepad | ) |

extern

Close a gamepad previously opened with SDL_OpenGamepad().

Parameters

  gamepad | a gamepad identifier previously returned by SDL_OpenGamepad().

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_OpenGamepad

## SDL_GamepadConnected()

bool SDL_GamepadConnected | ( | SDL_Gamepad * | gamepad | ) |

extern

Check if a gamepad has been opened and is currently connected.

Parameters

  gamepad | a gamepad identifier previously returned by SDL_OpenGamepad().

Returns
  true if the gamepad has been opened and is currently connected, or false if not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GamepadEventsEnabled()

bool SDL_GamepadEventsEnabled | ( | void |  | ) |

extern

Query the state of gamepad event processing.

If gamepad events are disabled, you must call SDL_UpdateGamepads() yourself and check the state of the gamepad when you want gamepad information.

Returns
  true if gamepad events are being processed, false otherwise.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetGamepadEventsEnabled

## SDL_GamepadHasAxis()

bool SDL_GamepadHasAxis | ( | SDL_Gamepad * | gamepad,
|  | SDL_GamepadAxis | axis )

extern

Query whether a gamepad has a given axis.

This merely reports whether the gamepad's mapping defined this axis, as that is all the information SDL has about the physical device.

Parameters

  gamepad | a gamepad.
  axis | an axis enum value (an SDL_GamepadAxis value).

Returns
  true if the gamepad has this axis, false otherwise.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GamepadHasButton
  SDL_GetGamepadAxis

## SDL_GamepadHasButton()

bool SDL_GamepadHasButton | ( | SDL_Gamepad * | gamepad,
|  | SDL_GamepadButton | button )

extern

Query whether a gamepad has a given button.

This merely reports whether the gamepad's mapping defined this button, as that is all the information SDL has about the physical device.

Parameters

  gamepad | a gamepad.
  button | a button enum value (an SDL_GamepadButton value).

Returns
  true if the gamepad has this button, false otherwise.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GamepadHasAxis

## SDL_GamepadHasSensor()

bool SDL_GamepadHasSensor | ( | SDL_Gamepad * | gamepad,
|  | SDL_SensorType | type )

extern

Return whether a gamepad has a particular sensor.

Parameters

  gamepad | the gamepad to query.
  type | the type of sensor to query.

Returns
  true if the sensor exists, false otherwise.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadSensorData
  SDL_GetGamepadSensorDataRate
  SDL_SetGamepadSensorEnabled

## SDL_GamepadSensorEnabled()

bool SDL_GamepadSensorEnabled | ( | SDL_Gamepad * | gamepad,
|  | SDL_SensorType | type )

extern

Query whether sensor data reporting is enabled for a gamepad.

Parameters

  gamepad | the gamepad to query.
  type | the type of sensor to query.

Returns
  true if the sensor is enabled, false otherwise.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetGamepadSensorEnabled

## SDL_GetGamepadAppleSFSymbolsNameForAxis()

const char * SDL_GetGamepadAppleSFSymbolsNameForAxis | ( | SDL_Gamepad * | gamepad,
|  | SDL_GamepadAxis | axis )

extern

Return the sfSymbolsName for a given axis on a gamepad on Apple platforms.

Parameters

  gamepad | the gamepad to query.
  axis | an axis on the gamepad.

Returns
  the sfSymbolsName or NULL if the name can't be found.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadAppleSFSymbolsNameForButton

## SDL_GetGamepadAppleSFSymbolsNameForButton()

const char * SDL_GetGamepadAppleSFSymbolsNameForButton | ( | SDL_Gamepad * | gamepad,
|  | SDL_GamepadButton | button )

extern

Return the sfSymbolsName for a given button on a gamepad on Apple platforms.

Parameters

  gamepad | the gamepad to query.
  button | a button on the gamepad.

Returns
  the sfSymbolsName or NULL if the name can't be found.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadAppleSFSymbolsNameForAxis

## SDL_GetGamepadAxis()

Sint16 SDL_GetGamepadAxis | ( | SDL_Gamepad * | gamepad,
|  | SDL_GamepadAxis | axis )

extern

Get the current state of an axis control on a gamepad.

The axis indices start at index 0.

For thumbsticks, the state is a value ranging from -32768 (up/left) to 32767 (down/right).

Triggers range from 0 when released to 32767 when fully pressed, and never return a negative value. Note that this differs from the value reported by the lower-level SDL_GetJoystickAxis(), which normally uses the full range.

Note that for invalid gamepads or axes, this will return 0. Zero is also a valid value in normal operation; usually it means a centered axis.

Parameters

  gamepad | a gamepad.
  axis | an axis index (one of the SDL_GamepadAxis values).

Returns
  axis state.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GamepadHasAxis
  SDL_GetGamepadButton

## SDL_GetGamepadAxisFromString()

SDL_GamepadAxis SDL_GetGamepadAxisFromString | ( | const char * | str | ) |

extern

Convert a string into SDL_GamepadAxis enum.

This function is called internally to translate SDL_Gamepad mapping strings for the underlying joystick device into the consistent SDL_Gamepad mapping. You do not normally need to call this function unless you are parsing SDL_Gamepad mappings in your own code.

Note specially that "righttrigger" and "lefttrigger" map to SDL_GAMEPAD_AXIS_RIGHT_TRIGGER and SDL_GAMEPAD_AXIS_LEFT_TRIGGER, respectively.

Parameters

  str | string representing a SDL_Gamepad axis.

Returns
  the SDL_GamepadAxis enum corresponding to the input string, or SDL_GAMEPAD_AXIS_INVALID if no match was found.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadStringForAxis

## SDL_GetGamepadBindings()

SDL_GamepadBinding ** SDL_GetGamepadBindings | ( | SDL_Gamepad * | gamepad,
|  | int * | count )

extern

Get the SDL joystick layer bindings for a gamepad.

Parameters

  gamepad | a gamepad.
  count | a pointer filled in with the number of bindings returned.

Returns
  a NULL terminated array of pointers to bindings or NULL on failure; call SDL_GetError() for more information. This is a single allocation that should be freed with SDL_free() when it is no longer needed.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadButton()

bool SDL_GetGamepadButton | ( | SDL_Gamepad * | gamepad,
|  | SDL_GamepadButton | button )

extern

Get the current state of a button on a gamepad.

Parameters

  gamepad | a gamepad.
  button | a button index (one of the SDL_GamepadButton values).

Returns
  true if the button is pressed, false otherwise.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GamepadHasButton
  SDL_GetGamepadAxis

## SDL_GetGamepadButtonFromString()

SDL_GamepadButton SDL_GetGamepadButtonFromString | ( | const char * | str | ) |

extern

Convert a string into an SDL_GamepadButton enum.

This function is called internally to translate SDL_Gamepad mapping strings for the underlying joystick device into the consistent SDL_Gamepad mapping. You do not normally need to call this function unless you are parsing SDL_Gamepad mappings in your own code.

Parameters

  str | string representing a SDL_Gamepad button.

Returns
  the SDL_GamepadButton enum corresponding to the input string, or SDL_GAMEPAD_BUTTON_INVALID if no match was found.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadStringForButton

## SDL_GetGamepadButtonLabel()

SDL_GamepadButtonLabel SDL_GetGamepadButtonLabel | ( | SDL_Gamepad * | gamepad,
|  | SDL_GamepadButton | button )

extern

Get the label of a button on a gamepad.

Parameters

  gamepad | a gamepad.
  button | a button index (one of the SDL_GamepadButton values).

Returns
  the SDL_GamepadButtonLabel enum corresponding to the button label.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadButtonLabelForType

## SDL_GetGamepadButtonLabelForType()

SDL_GamepadButtonLabel SDL_GetGamepadButtonLabelForType | ( | SDL_GamepadType | type,
|  | SDL_GamepadButton | button )

extern

Get the label of a button on a gamepad.

Parameters

  type | the type of gamepad to check.
  button | a button index (one of the SDL_GamepadButton values).

Returns
  the SDL_GamepadButtonLabel enum corresponding to the button label.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadButtonLabel

## SDL_GetGamepadConnectionState()

SDL_JoystickConnectionState SDL_GetGamepadConnectionState | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the connection state of a gamepad.

Parameters

  gamepad | the gamepad object to query.

Returns
  the connection state on success or SDL_JOYSTICK_CONNECTION_INVALID on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadFirmwareVersion()

Uint16 SDL_GetGamepadFirmwareVersion | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the firmware version of an opened gamepad, if available.

If the firmware version isn't available this function returns 0.

Parameters

  gamepad | the gamepad object to query.

Returns
  the gamepad firmware version, or zero if unavailable.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadFromID()

SDL_Gamepad * SDL_GetGamepadFromID | ( | SDL_JoystickID | instance_id | ) |

extern

Get the SDL_Gamepad associated with a joystick instance ID, if it has been opened.

Parameters

  instance_id | the joystick instance ID of the gamepad.

Returns
  an SDL_Gamepad on success or NULL on failure or if it hasn't been opened yet; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadFromPlayerIndex()

SDL_Gamepad * SDL_GetGamepadFromPlayerIndex | ( | int | player_index | ) |

extern

Get the SDL_Gamepad associated with a player index.

Parameters

  player_index | the player index, which different from the instance ID.

Returns
  the SDL_Gamepad associated with a player index.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadPlayerIndex
  SDL_SetGamepadPlayerIndex

## SDL_GetGamepadGUIDForID()

SDL_GUID SDL_GetGamepadGUIDForID | ( | SDL_JoystickID | instance_id | ) |

extern

Get the implementation-dependent GUID of a gamepad.

This can be called before any gamepads are opened.

Parameters

  instance_id | the joystick instance ID.

Returns
  the GUID of the selected gamepad. If called on an invalid index, this function returns a zero GUID.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GUIDToString
  SDL_GetGamepads

## SDL_GetGamepadID()

SDL_JoystickID SDL_GetGamepadID | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the instance ID of an opened gamepad.

Parameters

  gamepad | a gamepad identifier previously returned by SDL_OpenGamepad().

Returns
  the instance ID of the specified gamepad on success or 0 on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadJoystick()

SDL_Joystick * SDL_GetGamepadJoystick | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the underlying joystick from a gamepad.

This function will give you a SDL_Joystick object, which allows you to use the SDL_Joystick functions with a SDL_Gamepad object. This would be useful for getting a joystick's position at any given time, even if it hasn't moved (moving it would produce an event, which would have the axis' value).

The pointer returned is owned by the SDL_Gamepad. You should not call SDL_CloseJoystick() on it, for example, since doing so will likely cause SDL to crash.

Parameters

  gamepad | the gamepad object that you want to get a joystick from.

Returns
  an SDL_Joystick object, or NULL on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadMapping()

char * SDL_GetGamepadMapping | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the current mapping of a gamepad.

Details about mappings are discussed with SDL_AddGamepadMapping().

Parameters

  gamepad | the gamepad you want to get the current mapping for.

Returns
  a string that has the gamepad's mapping or NULL if no mapping is available; call SDL_GetError() for more information. This should be freed with SDL_free() when it is no longer needed.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_AddGamepadMapping
  SDL_GetGamepadMappingForID
  SDL_GetGamepadMappingForGUID
  SDL_SetGamepadMapping

## SDL_GetGamepadMappingForGUID()

char * SDL_GetGamepadMappingForGUID | ( | SDL_GUID | guid | ) |

extern

Get the gamepad mapping string for a given GUID.

Parameters

  guid | a structure containing the GUID for which a mapping is desired.

Returns
  a mapping string or NULL on failure; call SDL_GetError() for more information. This should be freed with SDL_free() when it is no longer needed.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetJoystickGUIDForID
  SDL_GetJoystickGUID

## SDL_GetGamepadMappingForID()

char * SDL_GetGamepadMappingForID | ( | SDL_JoystickID | instance_id | ) |

extern

Get the mapping of a gamepad.

This can be called before any gamepads are opened.

Parameters

  instance_id | the joystick instance ID.

Returns
  the mapping string. Returns NULL if no mapping is available. This should be freed with SDL_free() when it is no longer needed.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepads
  SDL_GetGamepadMapping

## SDL_GetGamepadMappings()

char ** SDL_GetGamepadMappings | ( | int * | count | ) |

extern

Get the current gamepad mappings.

Parameters

  count | a pointer filled in with the number of mappings returned, can be NULL.

Returns
  an array of the mapping strings, NULL-terminated, or NULL on failure; call SDL_GetError() for more information. This is a single allocation that should be freed with SDL_free() when it is no longer needed.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadName()

const char * SDL_GetGamepadName | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the implementation-dependent name for an opened gamepad.

Parameters

  gamepad | a gamepad identifier previously returned by SDL_OpenGamepad().

Returns
  the implementation dependent name for the gamepad, or NULL if there is no name or the identifier passed is invalid.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadNameForID

## SDL_GetGamepadNameForID()

const char * SDL_GetGamepadNameForID | ( | SDL_JoystickID | instance_id | ) |

extern

Get the implementation dependent name of a gamepad.

This can be called before any gamepads are opened.

Parameters

  instance_id | the joystick instance ID.

Returns
  the name of the selected gamepad. If no name can be found, this function returns NULL; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadName
  SDL_GetGamepads

## SDL_GetGamepadPath()

const char * SDL_GetGamepadPath | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the implementation-dependent path for an opened gamepad.

Parameters

  gamepad | a gamepad identifier previously returned by SDL_OpenGamepad().

Returns
  the implementation dependent path for the gamepad, or NULL if there is no path or the identifier passed is invalid.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadPathForID

## SDL_GetGamepadPathForID()

const char * SDL_GetGamepadPathForID | ( | SDL_JoystickID | instance_id | ) |

extern

Get the implementation dependent path of a gamepad.

This can be called before any gamepads are opened.

Parameters

  instance_id | the joystick instance ID.

Returns
  the path of the selected gamepad. If no path can be found, this function returns NULL; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadPath
  SDL_GetGamepads

## SDL_GetGamepadPlayerIndex()

int SDL_GetGamepadPlayerIndex | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the player index of an opened gamepad.

For XInput gamepads this returns the XInput user index.

Parameters

  gamepad | the gamepad object to query.

Returns
  the player index for gamepad, or -1 if it's not available.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_SetGamepadPlayerIndex

## SDL_GetGamepadPlayerIndexForID()

int SDL_GetGamepadPlayerIndexForID | ( | SDL_JoystickID | instance_id | ) |

extern

Get the player index of a gamepad.

This can be called before any gamepads are opened.

Parameters

  instance_id | the joystick instance ID.

Returns
  the player index of a gamepad, or -1 if it's not available.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadPlayerIndex
  SDL_GetGamepads

## SDL_GetGamepadPowerInfo()

SDL_PowerState SDL_GetGamepadPowerInfo | ( | SDL_Gamepad * | gamepad,
|  | int * | percent )

extern

Get the battery state of a gamepad.

You should never take a battery status as absolute truth. Batteries (especially failing batteries) are delicate hardware, and the values reported here are best estimates based on what that hardware reports. It's not uncommon for older batteries to lose stored power much faster than it reports, or completely drain when reporting it has 20 percent left, etc.

Parameters

  gamepad | the gamepad object to query.
  percent | a pointer filled in with the percentage of battery life left, between 0 and 100, or NULL to ignore. This will be filled in with -1 we can't determine a value or there is no battery.

Returns
  the current battery state.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadProduct()

Uint16 SDL_GetGamepadProduct | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the USB product ID of an opened gamepad, if available.

If the product ID isn't available this function returns 0.

Parameters

  gamepad | the gamepad object to query.

Returns
  the USB product ID, or zero if unavailable.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadProductForID

## SDL_GetGamepadProductForID()

Uint16 SDL_GetGamepadProductForID | ( | SDL_JoystickID | instance_id | ) |

extern

Get the USB product ID of a gamepad, if available.

This can be called before any gamepads are opened. If the product ID isn't available this function returns 0.

Parameters

  instance_id | the joystick instance ID.

Returns
  the USB product ID of the selected gamepad. If called on an invalid index, this function returns zero.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadProduct
  SDL_GetGamepads

## SDL_GetGamepadProductVersion()

Uint16 SDL_GetGamepadProductVersion | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the product version of an opened gamepad, if available.

If the product version isn't available this function returns 0.

Parameters

  gamepad | the gamepad object to query.

Returns
  the USB product version, or zero if unavailable.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadProductVersionForID

## SDL_GetGamepadProductVersionForID()

Uint16 SDL_GetGamepadProductVersionForID | ( | SDL_JoystickID | instance_id | ) |

extern

Get the product version of a gamepad, if available.

This can be called before any gamepads are opened. If the product version isn't available this function returns 0.

Parameters

  instance_id | the joystick instance ID.

Returns
  the product version of the selected gamepad. If called on an invalid index, this function returns zero.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadProductVersion
  SDL_GetGamepads

## SDL_GetGamepadProperties()

SDL_PropertiesID SDL_GetGamepadProperties | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the properties associated with an opened gamepad.

These properties are shared with the underlying joystick object.

The following read-only properties are provided by SDL:

- SDL_PROP_GAMEPAD_CAP_MONO_LED_BOOLEAN: true if this gamepad has an LED that has adjustable brightness
- SDL_PROP_GAMEPAD_CAP_RGB_LED_BOOLEAN: true if this gamepad has an LED that has adjustable color
- SDL_PROP_GAMEPAD_CAP_PLAYER_LED_BOOLEAN: true if this gamepad has a player LED
- SDL_PROP_GAMEPAD_CAP_RUMBLE_BOOLEAN: true if this gamepad has left/right rumble
- SDL_PROP_GAMEPAD_CAP_TRIGGER_RUMBLE_BOOLEAN: true if this gamepad has simple trigger rumble

Parameters

  gamepad | a gamepad identifier previously returned by SDL_OpenGamepad().

Returns
  a valid property ID on success or 0 on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepads()

SDL_JoystickID * SDL_GetGamepads | ( | int * | count | ) |

extern

Get a list of currently connected gamepads.

Parameters

  count | a pointer filled in with the number of gamepads returned, may be NULL.

Returns
  a 0 terminated array of joystick instance IDs or NULL on failure; call SDL_GetError() for more information. This should be freed with SDL_free() when it is no longer needed.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_HasGamepad
  SDL_OpenGamepad

## SDL_GetGamepadSensorData()

bool SDL_GetGamepadSensorData | ( | SDL_Gamepad * | gamepad,
|  | SDL_SensorType | type,
|  | float * | data,
|  | int | num_values )

extern

Get the current state of a gamepad sensor.

The number of values and interpretation of the data is sensor dependent. See the remarks in SDL_SensorType for details for each type of sensor.

Parameters

  gamepad | the gamepad to query.
  type | the type of sensor to query.
  data | a pointer filled with the current sensor state.
  num_values | the number of values to write to data.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadSensorDataRate()

float SDL_GetGamepadSensorDataRate | ( | SDL_Gamepad * | gamepad,
|  | SDL_SensorType | type )

extern

Get the data rate (number of events per second) of a gamepad sensor.

Parameters

  gamepad | the gamepad to query.
  type | the type of sensor to query.

Returns
  the data rate, or 0.0f if the data rate is not available.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadSerial()

const char * SDL_GetGamepadSerial | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the serial number of an opened gamepad, if available.

Returns the serial number of the gamepad, or NULL if it is not available.

Parameters

  gamepad | the gamepad object to query.

Returns
  the serial number, or NULL if unavailable.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadSteamHandle()

Uint64 SDL_GetGamepadSteamHandle | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the Steam Input handle of an opened gamepad, if available.

Returns an InputHandle_t for the gamepad that can be used with Steam Input API: https://partner.steamgames.com/doc/api/ISteamInput

Parameters

  gamepad | the gamepad object to query.

Returns
  the gamepad handle, or 0 if unavailable.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_GetGamepadStringForAxis()

const char * SDL_GetGamepadStringForAxis | ( | SDL_GamepadAxis | axis | ) |

extern

Convert from an SDL_GamepadAxis enum to a string.

Parameters

  axis | an enum value for a given SDL_GamepadAxis.

Returns
  a string for the given axis, or NULL if an invalid axis is specified. The string returned is of the format used by SDL_Gamepad mapping strings.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadAxisFromString

## SDL_GetGamepadStringForButton()

const char * SDL_GetGamepadStringForButton | ( | SDL_GamepadButton | button | ) |

extern

Convert from an SDL_GamepadButton enum to a string.

Parameters

  button | an enum value for a given SDL_GamepadButton.

Returns
  a string for the given button, or NULL if an invalid button is specified. The string returned is of the format used by SDL_Gamepad mapping strings.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadButtonFromString

## SDL_GetGamepadStringForType()

const char * SDL_GetGamepadStringForType | ( | SDL_GamepadType | type | ) |

extern

Convert from an SDL_GamepadType enum to a string.

Parameters

  type | an enum value for a given SDL_GamepadType.

Returns
  a string for the given type, or NULL if an invalid type is specified. The string returned is of the format used by SDL_Gamepad mapping strings.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadTypeFromString

## SDL_GetGamepadTouchpadFinger()

bool SDL_GetGamepadTouchpadFinger | ( | SDL_Gamepad * | gamepad,
|  | int | touchpad,
|  | int | finger,
|  | bool * | down,
|  | float * | x,
|  | float * | y,
|  | float * | pressure )

extern

Get the current state of a finger on a touchpad on a gamepad.

Parameters

  gamepad | a gamepad.
  touchpad | a touchpad.
  finger | a finger.
  down | a pointer filled with true if the finger is down, false otherwise, may be NULL.
  x | a pointer filled with the x position, normalized 0 to 1, with the origin in the upper left, may be NULL.
  y | a pointer filled with the y position, normalized 0 to 1, with the origin in the upper left, may be NULL.
  pressure | a pointer filled with pressure value, may be NULL.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetNumGamepadTouchpadFingers

## SDL_GetGamepadType()

SDL_GamepadType SDL_GetGamepadType | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the type of an opened gamepad.

Parameters

  gamepad | the gamepad object to query.

Returns
  the gamepad type, or SDL_GAMEPAD_TYPE_UNKNOWN if it's not available.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadTypeForID

## SDL_GetGamepadTypeForID()

SDL_GamepadType SDL_GetGamepadTypeForID | ( | SDL_JoystickID | instance_id | ) |

extern

Get the type of a gamepad.

This can be called before any gamepads are opened.

Parameters

  instance_id | the joystick instance ID.

Returns
  the gamepad type.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadType
  SDL_GetGamepads
  SDL_GetRealGamepadTypeForID

## SDL_GetGamepadTypeFromString()

SDL_GamepadType SDL_GetGamepadTypeFromString | ( | const char * | str | ) |

extern

Convert a string into SDL_GamepadType enum.

This function is called internally to translate SDL_Gamepad mapping strings for the underlying joystick device into the consistent SDL_Gamepad mapping. You do not normally need to call this function unless you are parsing SDL_Gamepad mappings in your own code.

Parameters

  str | string representing a SDL_GamepadType type.

Returns
  the SDL_GamepadType enum corresponding to the input string, or SDL_GAMEPAD_TYPE_UNKNOWN if no match was found.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadStringForType

## SDL_GetGamepadVendor()

Uint16 SDL_GetGamepadVendor | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the USB vendor ID of an opened gamepad, if available.

If the vendor ID isn't available this function returns 0.

Parameters

  gamepad | the gamepad object to query.

Returns
  the USB vendor ID, or zero if unavailable.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadVendorForID

## SDL_GetGamepadVendorForID()

Uint16 SDL_GetGamepadVendorForID | ( | SDL_JoystickID | instance_id | ) |

extern

Get the USB vendor ID of a gamepad, if available.

This can be called before any gamepads are opened. If the vendor ID isn't available this function returns 0.

Parameters

  instance_id | the joystick instance ID.

Returns
  the USB vendor ID of the selected gamepad. If called on an invalid index, this function returns zero.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadVendor
  SDL_GetGamepads

## SDL_GetNumGamepadTouchpadFingers()

int SDL_GetNumGamepadTouchpadFingers | ( | SDL_Gamepad * | gamepad,
|  | int | touchpad )

extern

Get the number of supported simultaneous fingers on a touchpad on a game gamepad.

Parameters

  gamepad | a gamepad.
  touchpad | a touchpad.

Returns
  number of supported simultaneous fingers.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadTouchpadFinger
  SDL_GetNumGamepadTouchpads

## SDL_GetNumGamepadTouchpads()

int SDL_GetNumGamepadTouchpads | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the number of touchpads on a gamepad.

Parameters

  gamepad | a gamepad.

Returns
  number of touchpads.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetNumGamepadTouchpadFingers

## SDL_GetRealGamepadType()

SDL_GamepadType SDL_GetRealGamepadType | ( | SDL_Gamepad * | gamepad | ) |

extern

Get the type of an opened gamepad, ignoring any mapping override.

Parameters

  gamepad | the gamepad object to query.

Returns
  the gamepad type, or SDL_GAMEPAD_TYPE_UNKNOWN if it's not available.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetRealGamepadTypeForID

## SDL_GetRealGamepadTypeForID()

SDL_GamepadType SDL_GetRealGamepadTypeForID | ( | SDL_JoystickID | instance_id | ) |

extern

Get the type of a gamepad, ignoring any mapping override.

This can be called before any gamepads are opened.

Parameters

  instance_id | the joystick instance ID.

Returns
  the gamepad type.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadTypeForID
  SDL_GetGamepads
  SDL_GetRealGamepadType

## SDL_HasGamepad()

bool SDL_HasGamepad | ( | void |  | ) |

extern

Return whether a gamepad is currently connected.

Returns
  true if a gamepad is connected, false otherwise.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepads

## SDL_IsGamepad()

bool SDL_IsGamepad | ( | SDL_JoystickID | instance_id | ) |

extern

Check if the given joystick is supported by the gamepad interface.

Parameters

  instance_id | the joystick instance ID.

Returns
  true if the given joystick is supported by the gamepad interface, false if it isn't or it's an invalid index.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetJoysticks
  SDL_OpenGamepad

## SDL_OpenGamepad()

SDL_Gamepad * SDL_OpenGamepad | ( | SDL_JoystickID | instance_id | ) |

extern

Open a gamepad for use.

Parameters

  instance_id | the joystick instance ID.

Returns
  a gamepad identifier or NULL if an error occurred; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_CloseGamepad
  SDL_IsGamepad

## SDL_ReloadGamepadMappings()

bool SDL_ReloadGamepadMappings | ( | void |  | ) |

extern

Reinitialize the SDL mapping database to its initial state.

This will generate gamepad events as needed if device mappings change.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_RumbleGamepad()

bool SDL_RumbleGamepad | ( | SDL_Gamepad * | gamepad,
|  | Uint16 | low_frequency_rumble,
|  | Uint16 | high_frequency_rumble,
|  | Uint32 | duration_ms )

extern

Start a rumble effect on a gamepad.

Each call to this function cancels any previous rumble effect, and calling it with 0 intensity stops any rumbling.

This function requires you to process SDL events or call SDL_UpdateJoysticks() to update rumble state.

Parameters

  gamepad | the gamepad to vibrate.
  low_frequency_rumble | the intensity of the low frequency (left) rumble motor, from 0 to 0xFFFF.
  high_frequency_rumble | the intensity of the high frequency (right) rumble motor, from 0 to 0xFFFF.
  duration_ms | the duration of the rumble effect, in milliseconds.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_RumbleGamepadTriggers()

bool SDL_RumbleGamepadTriggers | ( | SDL_Gamepad * | gamepad,
|  | Uint16 | left_rumble,
|  | Uint16 | right_rumble,
|  | Uint32 | duration_ms )

extern

Start a rumble effect in the gamepad's triggers.

Each call to this function cancels any previous trigger rumble effect, and calling it with 0 intensity stops any rumbling.

Note that this is rumbling of the triggers and not the gamepad as a whole. This is currently only supported on Xbox One gamepads. If you want the (more common) whole-gamepad rumble, use SDL_RumbleGamepad() instead.

This function requires you to process SDL events or call SDL_UpdateJoysticks() to update rumble state.

Parameters

  gamepad | the gamepad to vibrate.
  left_rumble | the intensity of the left trigger rumble motor, from 0 to 0xFFFF.
  right_rumble | the intensity of the right trigger rumble motor, from 0 to 0xFFFF.
  duration_ms | the duration of the rumble effect, in milliseconds.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_RumbleGamepad

## SDL_SendGamepadEffect()

bool SDL_SendGamepadEffect | ( | SDL_Gamepad * | gamepad,
|  | const void * | data,
|  | int | size )

extern

Send a gamepad specific effect packet.

Parameters

  gamepad | the gamepad to affect.
  data | the data to send to the gamepad.
  size | the size of the data to send to the gamepad.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

References size.

## SDL_SetGamepadEventsEnabled()

void SDL_SetGamepadEventsEnabled | ( | bool | enabled | ) |

extern

Set the state of gamepad event processing.

If gamepad events are disabled, you must call SDL_UpdateGamepads() yourself and check the state of the gamepad when you want gamepad information.

Parameters

  enabled | whether to process gamepad events or not.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GamepadEventsEnabled
  SDL_UpdateGamepads

## SDL_SetGamepadLED()

bool SDL_SetGamepadLED | ( | SDL_Gamepad * | gamepad,
|  | Uint8 | red,
|  | Uint8 | green,
|  | Uint8 | blue )

extern

Update a gamepad's LED color.

An example of a joystick LED is the light on the back of a PlayStation 4's DualShock 4 controller.

For gamepads with a single color LED, the maximum of the RGB values will be used as the LED brightness.

Parameters

  gamepad | the gamepad to update.
  red | the intensity of the red LED.
  green | the intensity of the green LED.
  blue | the intensity of the blue LED.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

## SDL_SetGamepadMapping()

bool SDL_SetGamepadMapping | ( | SDL_JoystickID | instance_id,
|  | const char * | mapping )

extern

Set the current mapping of a joystick or gamepad.

Details about mappings are discussed with SDL_AddGamepadMapping().

Parameters

  instance_id | the joystick instance ID.
  mapping | the mapping to use for this device, or NULL to clear the mapping.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_AddGamepadMapping
  SDL_GetGamepadMapping

## SDL_SetGamepadPlayerIndex()

bool SDL_SetGamepadPlayerIndex | ( | SDL_Gamepad * | gamepad,
|  | int | player_index )

extern

Set the player index of an opened gamepad.

Parameters

  gamepad | the gamepad object to adjust.
  player_index | player index to assign to this gamepad, or -1 to clear the player index and turn off player LEDs.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GetGamepadPlayerIndex

## SDL_SetGamepadSensorEnabled()

bool SDL_SetGamepadSensorEnabled | ( | SDL_Gamepad * | gamepad,
|  | SDL_SensorType | type,
|  | bool | enabled )

extern

Set whether data reporting for a gamepad sensor is enabled.

Parameters

  gamepad | the gamepad to update.
  type | the type of sensor to enable/disable.
  enabled | whether data reporting should be enabled.

Returns
  true on success or false on failure; call SDL_GetError() for more information.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.

See also
  SDL_GamepadHasSensor
  SDL_GamepadSensorEnabled

## SDL_UpdateGamepads()

void SDL_UpdateGamepads | ( | void |  | ) |

extern

Manually pump gamepad updates if not using the loop.

This function is called automatically by the event loop if events are enabled. Under such circumstances, it will not be necessary to call this function.

\threadsafety It is safe to call this function from any thread.

Since
  This function is available since SDL 3.2.0.